package com.example.jim.mytestapplication;

import android.content.Context;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.TextView;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;

public class ResultItemsAdapter extends ArrayAdapter<JSONObject> {
        public ResultItemsAdapter(Context context, int c, ArrayList<JSONObject> resultList) {

            super(context, c, resultList);
        }

        @Override
        public View getView(int position, View convertView, ViewGroup parent) {
            // Get the data item for this position
            JSONObject result = getItem(position);
            if (result!=null) {
                // Check if an existing view is being reused, otherwise inflate the view
                if (convertView == null) {
                    convertView = LayoutInflater.from(getContext()).inflate(R.layout.item_result, parent, false);
                }
                // Lookup view for data population
                TextView desc = (TextView) convertView.findViewById(R.id.Description);
                TextView title = (TextView) convertView.findViewById(R.id.Title);
                // Populate the data into the template view using the data object
                try {
                    desc.setText(result.get("Summary").toString());
                    title.setText(result.get("Title").toString());
                } catch (JSONException e) {
                    Log.d("SearchResultsActivity", e.toString());
                }
            }
            // Return the completed view to render on screen
            return convertView;
        }
    }
