package com.example.jim.mytestapplication;

import android.app.ListActivity;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.content.Intent;
import android.app.SearchManager;
import android.widget.ArrayAdapter;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.HttpClient;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.StringEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.util.EntityUtils;
import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLEncoder;
import java.util.ArrayList;


public class SearchActivity extends ListActivity {


    class SearchTask extends AsyncTask<String, Void, JSONObject> {

        String serverAddress = "http://192.168.1.103";
        String appRoot = "/SearchUnit6-ServiceExample";

        private Exception exception;

        protected JSONObject doInBackground(String... query) {
            JSONObject jo = null;
            try {
                String SERVICE_URI = serverAddress + appRoot + "/Keyoti_SearchEngine_Web_Common/SearchService.svc";
                String urlFinal=SERVICE_URI+"/GetResults";

                String parameter = "{indexDirectory:'~/IndexDirectory',"+
                                    "query:'"+query[0]+"',"+
                                    "resultPage:1,"+
                                    "resultsPerPage:10,"+
                                    "locationName:'All',"+
                                    "contentNames:[],"+
                                    "securityGroupNames:[]," +
                                    "filterCollection:[],"+
                                    "sortBy:null,"+
                                    "language:'',"+
                                    "customDictionaryPath:'',"+
                                    "spellingSuggestionSource:'PresetDictionary'}";
                JSONObject holder = new JSONObject(parameter);
                StringEntity se = new StringEntity(holder.toString());

                //sets the post request as the resulting string


                HttpPost postMethod = new HttpPost(urlFinal.trim());//+""+ URLEncoder.encode(parameter, "UTF-8"));
                postMethod.setEntity(se);
                postMethod.setHeader("Accept", "application/json");
                postMethod.setHeader("Content-type", "application/json");

                HttpClient hc = new DefaultHttpClient();

                HttpResponse response = hc.execute(postMethod);
                Log.i("response", ""+response.toString());
                HttpEntity entity = response.getEntity();
                final String responseText = EntityUtils.toString(entity);
                jo = new JSONObject(responseText);
                //string=responseText;
                Log.i("Output", ""+responseText);



            } catch (Exception e) {
                Log.d("SearchResultsActivity", e.toString());
                exception = e;
            }

            try {
                if (jo != null)
                    return (JSONObject) jo.get("d");
            } catch (JSONException ex){
                Log.d("SearchResultsActivity", ex.toString());
            }

            return null;
        }

        protected void onPostExecute(JSONObject response) {
            if(response!=null) {
                try {

                    JSONArray results = (JSONArray) response.get("Results");
                    ArrayList<JSONObject> resultList = new ArrayList<JSONObject>(results.length());

                        for (int i = 0; i < results.length(); i++) {
                            resultList.add((JSONObject) results.get(i));
                        }


                    setListAdapter(new ResultItemsAdapter(SearchActivity.this, android.R.layout.simple_list_item_1, resultList));
                } catch (JSONException e) {
                    Log.d("SearchResultsActivity", e.toString());

                }

            }
        }
    }





    @Override
    protected void onCreate(Bundle savedInstanceState) {
        Log.d("SearchResultsActivity", "onCreate called");
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_search);
// Get the intent, verify the action and get the query
        Intent intent = getIntent();
        if (Intent.ACTION_SEARCH.equals(intent.getAction())) {
            String query = intent.getStringExtra(SearchManager.QUERY);

            //callSearch(query);
            new SearchTask().execute(query);

        }
    }



    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_search, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
